OBJ

  servo : "Servo32v3"
  uart  : "FullDuplexSerialPlus"
  conv  : "libraryEngine"
  
CON

  _clkmode = xtal1 + pll16x                                                     'Sets clock to 16x input
  _xinfreq = 5_000_000                                                          'Sets clock to 80MHz (16x 5_000_000)

  throttlePin = 4                                                              'Sets pin to ESC on prop
  
VAR

  long uartPulse
  byte inBuffer[5]
  
PUB Main | oldPulse, index 

  uart.start(31, 30, 0, 115200)                                                 'Start FDS object for recieving data from com port
  servo.set(throttlePin, 2200)                                                  'Initializing ESC to full throttle
  servo.start

  InitESC                                                                       'Arming Electrifly ESC as per to manual

  ''Loop constantly for a new pulse width
  repeat

    repeat index from 0 to 5
      inbuffer[index] := uart.rx                                                 'Sets uartPulse to value coming in com port
                                                            
    uartPulse := conv.decimalToNumber(@inBuffer[0])                                 'Convert to dec                                                    

      if (uartPulse <> oldPulse)                                                 'If uartPulse changes for set for new pulse
        servo.set(throttlePin, uartPulse)
        
      else                                                                     'If values dont change throttle stays the same
        servo.set(throttlePin, oldPulse) 

      oldPulse := uartPulse                                                       'Sets oldPulse to uartPulse for comparison
    
PUB RecieveData | throttle
''To be coded
PRI InitESC

  servo.set(throttlePin, 2200)                                                  'ESC full throttle
  pauseForSeconds(5)
  servo.set(throttlePin, 1000)                                                  'ESC full brake
  pauseForSeconds(2)
  servo.set(throttlePin, 2200)                                                  'ESC full throttle
  pauseForSeconds(2)
  servo.set(throttlePin, 1000)                                                  'ESC full brake

PRI pauseForSeconds(value)

  pauseForMilliseconds(value * 1000)

PRI pauseForMilliseconds(value) | buffer

  buffer := cnt 
 
  repeat (value #> 0)
    buffer += (clkfreq / 1000)
    waitcnt(buffer)